DECLARE SUB capture (x!, y!, sx!)

REM SPRITE16.BAS
REM 16 by 16 pixel sprite drawing program Version 5.0b
REM Programmed by John Richard Munro Using Microsoft QBasic
REM (C) COPYRIGHT 1995 All Rights Reserved
REM
REM -NOTE- The sprites are saved in "*.hrs" (32644 byte High Resolution
REM        Sprite) form, and cannot be read or modified using any other
REM        program.
REM
REM The keys are:
REM
REM    8 ---------- Up
REM    2 ---------- Down
REM    4 ---------- Left
REM    6 ---------- Right
REM    Space Bar -- Paint selected colour
REM    + ---------- Select next colour
REM    - ---------- Select previous colour
REM    0 ---------- Colour black
REM    . ---------- Capture colour

DECLARE SUB save (Sprite!(), x, y, sx)
DECLARE SUB load (Sprite!(), x, y, sx)
DECLARE SUB take (x!, y!, sx!)
DECLARE SUB place (x!, y!, sx!)
DECLARE SUB keys (i$, x!, y!, sx!, Sprite!())
DECLARE SUB lpaintit (x!, y!)
DECLARE SUB paintit (x!, y!, sx!, Sprite!())
DECLARE SUB background ()

SCREEN 13
DIM Sprite(256)
DIM SHARED john%(242)
x = 5
y = 5
sx = 2

CALL background

DO
   i$ = LCASE$(INKEY$)

   CALL take(x, y, sx)
   CALL keys(i$, x, y, sx, Sprite())
   CALL place(x, y, sx)
LOOP

SUB background

CLS
COLOR 11

' outside box
LINE (1, 1)-(319, 199), , B

' 256 colors
FOR c = 0 TO 255
   clr = c + 2
   LINE (clr, 175)-(clr, 199), c
NEXT c

' colors box
LINE (1, 175)-(257, 199), , B

' grid vertical lines
FOR verti = 1 TO 16
   h = h + 10
   LINE (h, 1)-(h, 160)
NEXT verti

' grid horizontal lines
FOR horiz = 1 TO 16
   v = v + 10
   LINE (1, v)-(160, v)
NEXT horiz

' actual sprite box
LINE (238, 16)-(257, 35), , B

' command keys
LOCATE 8, 30
COLOR 12
PRINT "S";
COLOR 11
PRINT "ave"

LOCATE 10, 30
COLOR 12
PRINT "L";
COLOR 11
PRINT "oad"

LOCATE 12, 30
COLOR 12
PRINT "N";
COLOR 11
PRINT "ew"

LOCATE 14, 30
COLOR 12
PRINT "E";
COLOR 11
PRINT "xit"

LOCATE 19, 23
COLOR 11
PRINT "Current:"

LOCATE 20, 23
COLOR 11
PRINT "Selected:"

END SUB

SUB capture (x, y, sx)
sx = POINT(x, y)
sx = sx + 2
END SUB

SUB keys (i$, x, y, sx, Sprite())
   IF i$ = "s" THEN CALL save(Sprite(), x, y, sx)
   IF i$ = "l" THEN CALL load(Sprite(), x, y, sx)
   IF i$ = "n" THEN ERASE Sprite: CALL background: x = 5: y = 5: sx = 2
   IF i$ = "e" THEN GOTO esc
 
   IF i$ = "8" AND y > 10 THEN y = y - 10
   IF i$ = "2" AND y < 150 THEN y = y + 10
   IF i$ = "4" AND x > 10 THEN x = x - 10
   IF i$ = "6" AND x < 150 THEN x = x + 10
   IF i$ = "0" THEN sx = 2
   IF i$ = "." THEN CALL capture(x, y, sx)

   IF i$ = "+" AND sx < 255 THEN sx = sx + 1
   IF i$ = "-" AND sx > 2 THEN sx = sx - 1

   IF i$ = " " OR i$ = CHR$(13) THEN CALL paintit(x, y, sx, Sprite())

   GOTO notesc:

esc:
   CLS
   COLOR 7
   END
notesc:
END SUB

SUB load (Sprite(), x, y, sx)
COLOR 11

LOCATE 8, 27
PRINT "          "
LOCATE 12, 27
PRINT "          "
LOCATE 14, 27
PRINT "          "
LOCATE 10, 25
PRINT "Load  File  "
LOCATE 11, 25
INPUT "Name"; lname$
lname$ = lname$ + ".hrs"
IF lname$ = "" THEN GOTO cancel

OPEN lname$ FOR RANDOM ACCESS READ AS #2

FOR t = 1 TO 256
 GET #2, t, Sprite(t)
NEXT t

CLOSE #2

cancel:
CALL background
IF Sprite(1) <> 0 THEN PUT (239, 17), Sprite(1)
CALL lpaintit(x, y)
x = 5
y = 5
sx = 2

END SUB

SUB lpaintit (x, y)

 FOR x = 5 TO 160 STEP 10
    FOR y = 5 TO 160 STEP 10
       rx = x / 9.5
       ry = y / 9.5
       sx = POINT(rx + 239, ry + 17)
       LINE (x - 3, y - 3)-(x + 4, y + 4), sx, BF
    NEXT y
 NEXT x

END SUB

SUB paintit (x, y, sx, Sprite())
 LINE (x - 3, y - 3)-(x + 4, y + 4), sx - 2, BF

 rx = x / 9.5
 ry = y / 9.5
 PSET (rx + 239, ry + 17), sx - 2
 LOCATE 20, 30
END SUB

SUB place (x, y, sx)
   PSET (x, 162), 12
   PSET (x, 163), 12
   PSET (x - 1, 163), 12
   PSET (x + 1, 163), 12
 
   PSET (162, y), 12
   PSET (163, y), 12
   PSET (163, y - 1), 12
   PSET (163, y + 1), 12
 
   PSET (sx, 173), 12
   PSET (sx, 172), 12
   IF sx > 2 THEN PSET (sx - 1, 172), 12
   PSET (sx + 1, 172), 12

   clr = POINT(x, y)
   LOCATE 19, 32
   COLOR clr
   PRINT clr
  
   LOCATE 20, 32
   COLOR sx - 2
   PRINT sx - 2

END SUB

SUB save (Sprite(), x, y, sx)
COLOR 11

LOCATE 8, 27
PRINT "          "
LOCATE 12, 27
PRINT "          "
LOCATE 14, 27
PRINT "          "
LOCATE 10, 25
PRINT "Save  File  "
LOCATE 11, 25
INPUT "Name"; sname$
sname$ = sname$ + ".hrs"
IF sname$ = "" THEN CALL background: GOTO cancelled

GET (239, 17)-(256, 34), Sprite(1)

CALL background

OPEN sname$ FOR RANDOM ACCESS WRITE AS #1

FOR t = 1 TO 256
PUT #1, t, Sprite(t)
NEXT t

CLOSE #1

cancelled:
IF Sprite(1) <> 0 THEN PUT (239, 17), Sprite(1)
CALL lpaintit(x, y)
x = 5
y = 5
sx = 2

END SUB

SUB take (x, y, sx)
   PRESET (x, 162)
   PRESET (x, 163)
   PRESET (x - 1, 163)
   PRESET (x + 1, 163)

   PRESET (162, y)
   PRESET (163, y)
   PRESET (163, y - 1)
   PRESET (163, y + 1)
 
   PRESET (sx, 173)
   PRESET (sx, 172)
   IF sx > 2 THEN PRESET (sx - 1, 172)
   PRESET (sx + 1, 172)
END SUB

